'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.render = exports.router = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var render = exports.render = function () {
  var _ref2 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(props) {
    var onError = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : renderErrorComponent;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.prev = 0;
            _context.next = 3;
            return doRender(props);

          case 3:
            _context.next = 9;
            break;

          case 5:
            _context.prev = 5;
            _context.t0 = _context['catch'](0);
            _context.next = 9;
            return onError(_context.t0);

          case 9:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this, [[0, 5]]);
  }));

  return function render(_x) {
    return _ref2.apply(this, arguments);
  };
}();

var renderErrorComponent = function () {
  var _ref3 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2(err) {
    var pathname, query, props;
    return _regenerator2.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            pathname = router.pathname, query = router.query;
            _context2.next = 3;
            return (0, _utils.loadGetInitialProps)(ErrorComponent, { err: err, pathname: pathname, query: query });

          case 3:
            props = _context2.sent;
            _context2.next = 6;
            return doRender({ Component: ErrorComponent, props: props, err: err });

          case 6:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, this);
  }));

  return function renderErrorComponent(_x3) {
    return _ref3.apply(this, arguments);
  };
}();

var doRender = function () {
  var _ref4 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3(_ref5) {
    var Component = _ref5.Component,
        props = _ref5.props,
        hash = _ref5.hash,
        err = _ref5.err,
        emitter = _ref5.emitter;

    var _pathname, _query, appProps;

    return _regenerator2.default.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            if (!(!props && Component && Component !== ErrorComponent && lastAppProps.Component === ErrorComponent)) {
              _context3.next = 5;
              break;
            }

            // fetch props if ErrorComponent was replaced with a page component by HMR
            _pathname = router.pathname, _query = router.query;
            _context3.next = 4;
            return (0, _utils.loadGetInitialProps)(Component, { err: err, pathname: _pathname, query: _query });

          case 4:
            props = _context3.sent;

          case 5:

            if (emitter) {
              emitter.emit('before-reactdom-render', { Component: Component });
            }

            Component = Component || lastAppProps.Component;
            props = props || lastAppProps.props;

            appProps = { Component: Component, props: props, hash: hash, err: err, router: router, headManager: headManager };
            // lastAppProps has to be set before ReactDom.render to account for ReactDom throwing an error.

            lastAppProps = appProps;

            _reactDom2.default.render((0, _react.createElement)(_app2.default, appProps), container);

            if (emitter) {
              emitter.emit('after-reactdom-render', { Component: Component });
            }

          case 12:
          case 'end':
            return _context3.stop();
        }
      }
    }, _callee3, this);
  }));

  return function doRender(_x4) {
    return _ref4.apply(this, arguments);
  };
}();

var _react = require('react');

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _events = require('events');

var _headManager = require('./head-manager');

var _headManager2 = _interopRequireDefault(_headManager);

var _router = require('../lib/router');

var _app = require('../lib/app');

var _app2 = _interopRequireDefault(_app);

var _evalScript = require('../lib/eval-script');

var _evalScript2 = _interopRequireDefault(_evalScript);

var _utils = require('../lib/utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _window = window,
    _window$__NEXT_DATA__ = _window.__NEXT_DATA__,
    component = _window$__NEXT_DATA__.component,
    errorComponent = _window$__NEXT_DATA__.errorComponent,
    props = _window$__NEXT_DATA__.props,
    err = _window$__NEXT_DATA__.err,
    pathname = _window$__NEXT_DATA__.pathname,
    query = _window$__NEXT_DATA__.query,
    location = _window.location;


var Component = (0, _evalScript2.default)(component).default;
var ErrorComponent = (0, _evalScript2.default)(errorComponent).default;
var lastAppProps = void 0;

var router = exports.router = (0, _router.createRouter)(pathname, query, (0, _utils.getURL)(), {
  Component: Component,
  ErrorComponent: ErrorComponent,
  err: err
});

var headManager = new _headManager2.default();
var container = document.getElementById('__next');

exports.default = function (onError) {
  var emitter = new _events.EventEmitter();

  router.subscribe(function (_ref) {
    var Component = _ref.Component,
        props = _ref.props,
        hash = _ref.hash,
        err = _ref.err;

    render({ Component: Component, props: props, err: err, hash: hash, emitter: emitter }, onError);
  });

  var hash = location.hash.substring(1);
  render({ Component: Component, props: props, hash: hash, err: err, emitter: emitter }, onError);

  return emitter;
};